searchNodes=[{"type":"task","title":"Mix.Tasks.Altworx.ScenarioRelease","doc":"Assembles an Altworx scenario release for the current project. It is done in a docker container based on an image which ensures correct erlang and Elixir versions, so they are compatible with Altworx. $ mix altworx.scenario_release","ref":"Mix.Tasks.Altworx.ScenarioRelease.html"},{"type":"task","title":"Mix.Tasks.Altworx.ScenarioReleaseInternal","doc":"Assembles an Altworx scenario release for the current project. $ MIX_ENV=prod mix altworx.scenario_release_internal Command line options --force - forces recompilation --no-archives-check - does not check archive --no-deps-check - does not check dependencies --no-elixir-version-check - does not check Elixir version --no-compile - does not compile before assembling the release --overwrite - if there is an existing release version, overwrite it --path - the path of the release --quiet - does not write progress to the standard output --version - the version of the release","ref":"Mix.Tasks.Altworx.ScenarioReleaseInternal.html"},{"type":"module","title":"Runbox","doc":"Runbox allows working with scenario releases. It can load scenario releases and provide information about the individual scenarios within them.","ref":"Runbox.html"},{"type":"function","title":"Runbox.generate_state_for_run_component/2","doc":"Generates initial state for run component on run slave node. Because function should be called from code implementing scenario type (for example stage based), returned value is also specific for scenario type.","ref":"Runbox.html#generate_state_for_run_component/2"},{"type":"function","title":"Runbox.get_release_scenarios/1","doc":"Retrieves information about scenarios in a release.","ref":"Runbox.html#get_release_scenarios/1"},{"type":"function","title":"Runbox.list_scenario_notification_channels/4","doc":"Lists all channels with templates defined for scenario, notification type and template type.","ref":"Runbox.html#list_scenario_notification_channels/4"},{"type":"function","title":"Runbox.list_scenario_notification_languages/5","doc":"Lists all template languages defined for senario, notification type, template type and channel.","ref":"Runbox.html#list_scenario_notification_languages/5"},{"type":"function","title":"Runbox.list_scenario_notification_template_types/3","doc":"Lists all template types of the specified notification.","ref":"Runbox.html#list_scenario_notification_template_types/3"},{"type":"function","title":"Runbox.list_scenario_notification_types/2","doc":"Lists all notification types for a scenario.","ref":"Runbox.html#list_scenario_notification_types/2"},{"type":"function","title":"Runbox.load_and_eval_scenario_notification_templates/8","doc":"Loads and evaluates templates specified by scenario, notification type, template type, channel and language. If language is not defined or does not exist, fallback_language is used.","ref":"Runbox.html#load_and_eval_scenario_notification_templates/8"},{"type":"function","title":"Runbox.load_scenario_notification_spec/2","doc":"Tries to load the notification spec of the given scenario. Returns {:ok, notification_spec} if the spec is found {:error, :cannot_load, exception} if the spec file cannot be found {:error, :bad_syntax, exception} if the spec file was found but contains syntactic errors","ref":"Runbox.html#load_scenario_notification_spec/2"},{"type":"function","title":"Runbox.run_on_start/2","doc":"Runs on_start function of scenario on run slave node.","ref":"Runbox.html#run_on_start/2"},{"type":"function","title":"Runbox.save_entity/3","doc":"Saves entity state to state store running on run master node. This call is called from slave to master.","ref":"Runbox.html#save_entity/3"},{"type":"function","title":"Runbox.start_link_run_environment/2","doc":"Starts new environment for run. Every run runs on own slave node. Caller process is linked with supervisor started during this call. Started supervisor will supervise all run components running on slave node.","ref":"Runbox.html#start_link_run_environment/2"},{"type":"function","title":"Runbox.start_release_node/2","doc":"Starts slave node for release in release_dir . If app_env is set, configured applications env variables are set on slave node (for example ui_url variable is needed to be set in runbox application env if node is used for notifications evaluation, i.e. app_env must be set to [runbox: [ui_url: &quot;https://some_url&quot;]] ).","ref":"Runbox.html#start_release_node/2"},{"type":"function","title":"Runbox.start_run_component/3","doc":"Starts scenario component on slave node.","ref":"Runbox.html#start_run_component/3"},{"type":"module","title":"Runbox.Deduplicator","doc":"Decide if a message is a duplicate by comparing it to messages already seen. Only messages with the biggest timestamp are remembered as &quot;seen&quot;. If the actual message has lower timestamp than the messages in &quot;seen&quot;, it is considered &quot;old&quot;. If it has the exact same timestamp, it is compared for equality with all the &quot;seen&quot; messages and if it matches, it is considered &quot;duplicate&quot;. In any other case, the message is considered &quot;new&quot;.","ref":"Runbox.Deduplicator.html"},{"type":"function","title":"Runbox.Deduplicator.deduplicate/2","doc":"Decides if a given message is a duplicate or not. Returns a tuple with {msg_condition, deduplicator_state} where msg_condition can be one of: :new - message is new and was not yet seen. :old - message is older than the messages already seen. :duplicate - message is equal to one of the latest messages already seen.","ref":"Runbox.Deduplicator.html#deduplicate/2"},{"type":"function","title":"Runbox.Deduplicator.new/2","doc":"Initializes a deduplicator. stream is an enumerable (possibly empty), which contains messages with descending timestamps - from newest to oldest. It is used to initialize &quot;seen&quot; messages from messages which were already processed. extract_timestamp is a function which returns a timestamp for a given message.","ref":"Runbox.Deduplicator.html#new/2"},{"type":"opaque","title":"Runbox.Deduplicator.t/0","doc":"","ref":"Runbox.Deduplicator.html#t:t/0"},{"type":"module","title":"Runbox.Master","doc":"Utilities for communicating with master node from slave node","ref":"Runbox.Master.html"},{"type":"function","title":"Runbox.Master.call/4","doc":"Calls a function on the master. Calls MFA on the master . See :erpc.call/4 for details.","ref":"Runbox.Master.html#call/4"},{"type":"module","title":"Runbox.Notifications.TemplateHelper","doc":"Set of utility functions for use in notification templates.","ref":"Runbox.Notifications.TemplateHelper.html"},{"type":"function","title":"Runbox.Notifications.TemplateHelper.asset_link/2","doc":"Returns a URL to the asset detail. The type of UI can be specified, and the link is generated to work with that UI. Can be :new or :old .","ref":"Runbox.Notifications.TemplateHelper.html#asset_link/2"},{"type":"function","title":"Runbox.Notifications.TemplateHelper.format_number/2","doc":"Formats a number by separating thousands with a separator.","ref":"Runbox.Notifications.TemplateHelper.html#format_number/2"},{"type":"function","title":"Runbox.Notifications.TemplateHelper.format_ts/3","doc":"Formats timestamp into the given format in the given timezone.","ref":"Runbox.Notifications.TemplateHelper.html#format_ts/3"},{"type":"macro","title":"Runbox.Notifications.TemplateHelper.include_template/4","doc":"Wraps the given EEx content with a EEx template. Templates can be bundled with a scenario or be a part of the system, source should be set to scenario_name for scenario-based templates and :system for templates bundled with the system. The templates that can be included, so called shared templates, are stored in shared folder ( scenarios/priv/notifications/{scenario_name}/shared ). Each shared template consists of two files - header and footer - which are wrapped around the given content. The filenames have _header and _footer appended, for template_name = &quot;email&quot; the two filenames are email_header.eex and email_footer.eex . System templates are stored in apps/asset_map/templates/shared . Via context you can pass additional parameters to the shared template (passed as assigns). The expected context depends on the template. Example usage &lt; % alias Runbox.Notifications.TemplateHelper % &gt; &lt; % require TemplateHelper % &gt; &lt; % = TemplateHelper . include_template ( { &quot;test&quot; , 1 } , &quot;email_rich&quot; , title : &quot;Test email&quot; ) do % &gt; &lt; h1 &gt; Test Email &lt; / h1 &gt; &lt; p &gt; This text is surrounded by the template ... &lt; / p &gt; &lt; % end % &gt;","ref":"Runbox.Notifications.TemplateHelper.html#include_template/4"},{"type":"function","title":"Runbox.Notifications.TemplateHelper.ui_url/0","doc":"Returns the UI url.","ref":"Runbox.Notifications.TemplateHelper.html#ui_url/0"},{"type":"module","title":"Runbox.RunContext","doc":"Structure holding Runbox context of running slave node.","ref":"Runbox.RunContext.html"},{"type":"type","title":"Runbox.RunContext.t/0","doc":"Context of running run slave node. :master_node - master node of run :node - slave node of run :sup_pid - pid of supervisor (running on slave) for run components running on slave :save_entity_mf - callback definition (module and functin name) for saving entity state. Function is always called with 2 params: entity ( Runbox.StateStore.Entity.t/0 ) and savepoint timestamp.","ref":"Runbox.RunContext.html#t:t/0"},{"type":"module","title":"Runbox.RunNode","doc":"Module contains common functions called on run slave node.","ref":"Runbox.RunNode.html"},{"type":"function","title":"Runbox.RunNode.start_run_component/3","doc":"Starts run component under run scenario.","ref":"Runbox.RunNode.html#start_run_component/3"},{"type":"function","title":"Runbox.RunNode.start_run_sup/1","doc":"Starts supervisor for run. All components of run running on slave node will run under this supervisor. OneForAll strategy with 0 max restart stops supervisor if any component crashes. Because run manager process running on master is linked with this supervisor, it also crashes (and it what we want).","ref":"Runbox.RunNode.html#start_run_sup/1"},{"type":"module","title":"Runbox.RunStartContext","doc":"Structure holding context of starting run. This structure is passed as param to every run component start.","ref":"Runbox.RunStartContext.html"},{"type":"function","title":"Runbox.RunStartContext.add_component/3","doc":"Adds pid of component identified by name to context.","ref":"Runbox.RunStartContext.html#add_component/3"},{"type":"function","title":"Runbox.RunStartContext.component_pid/2","doc":"Returns pid of component identitfied by name .","ref":"Runbox.RunStartContext.html#component_pid/2"},{"type":"type","title":"Runbox.RunStartContext.t/0","doc":"Currently context holds only mapping of names to pids of already started components.","ref":"Runbox.RunStartContext.html#t:t/0"},{"type":"module","title":"Runbox.Runtime.OutputAction","doc":"Output Action for internal use by Runtime","ref":"Runbox.Runtime.OutputAction.html"},{"type":"function","title":"Runbox.Runtime.OutputAction.is_oa_body?/1","doc":"Returns true if valid output action body.","ref":"Runbox.Runtime.OutputAction.html#is_oa_body?/1"},{"type":"function","title":"Runbox.Runtime.OutputAction.new/4","doc":"Creates a new output action. To produce a valid output action, the params have to be one of the accepted structs. See the documentation of the particular structs for details. If the params are not one of the accepted structs or some of the fields do not pass validation, it returns an output action with body set to Runbox.Scenario.OutputAction.BadOutputAction.t/0 with original params inside.","ref":"Runbox.Runtime.OutputAction.html#new/4"},{"type":"function","title":"Runbox.Runtime.OutputAction.valid?/1","doc":"Returns true if valid output action.","ref":"Runbox.Runtime.OutputAction.html#valid?/1"},{"type":"type","title":"Runbox.Runtime.OutputAction.t/0","doc":"Runtime Output Action","ref":"Runbox.Runtime.OutputAction.html#t:t/0"},{"type":"module","title":"Runbox.Runtime.RuntimeInstruction","doc":"Struct produced by scenario representing instruction for runtime.","ref":"Runbox.Runtime.RuntimeInstruction.html"},{"type":"function","title":"Runbox.Runtime.RuntimeInstruction.register_timeout/1","doc":"Creates runtime instruction to register timeout message.","ref":"Runbox.Runtime.RuntimeInstruction.html#register_timeout/1"},{"type":"type","title":"Runbox.Runtime.RuntimeInstruction.t/0","doc":"Struct produced by scenario representing instruction for runtime.","ref":"Runbox.Runtime.RuntimeInstruction.html#t:t/0"},{"type":"module","title":"Runbox.Runtime.RuntimeInstruction.Timeout","doc":"Instruction to register unit timeout.","ref":"Runbox.Runtime.RuntimeInstruction.Timeout.html"},{"type":"type","title":"Runbox.Runtime.RuntimeInstruction.Timeout.t/0","doc":"Struct representing unit timeout registration.","ref":"Runbox.Runtime.RuntimeInstruction.Timeout.html#t:t/0"},{"type":"module","title":"Runbox.Runtime.Stage.ComponentNetwork","doc":"Component network builds and validates template dependency network. To build this network, module uses Runbox.Scenario.Template.StageBased.subscriptions/0 . Only templates are defined at first, logic than derive input-topic nodes, timezip where one template subscribes to two stream, and output sink in the end.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html"},{"type":"function","title":"Runbox.Runtime.Stage.ComponentNetwork.convert_to_network/1","doc":"Creates base network with only template nodes","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#convert_to_network/1"},{"type":"function","title":"Runbox.Runtime.Stage.ComponentNetwork.create/2","doc":"Main function. Given list of template modules, expands them into components network with input streams, timezips etc... Options :direct_ticking - if true (default), creates network using direct ticking","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#create/2"},{"type":"function","title":"Runbox.Runtime.Stage.ComponentNetwork.input_topics/1","doc":"Return all input topic names that are being subscribed to in component network.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#input_topics/1"},{"type":"function","title":"Runbox.Runtime.Stage.ComponentNetwork.topology_sort/1","doc":"Sorts components (keys) of component network topologicaly, but according to backward edges, because edge means subscription relation (not comes after but comes before). So instead of indegree implementation use outdegee. Its wrath of kahn's algorithm.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#topology_sort/1"},{"type":"type","title":"Runbox.Runtime.Stage.ComponentNetwork.component/0","doc":"Full representation of particular component.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#t:component/0"},{"type":"type","title":"Runbox.Runtime.Stage.ComponentNetwork.component_type/0","doc":"Part of component identifier.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#t:component_type/0"},{"type":"type","title":"Runbox.Runtime.Stage.ComponentNetwork.subscription/0","doc":"Subscription edge defined with destination and props.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#t:subscription/0"},{"type":"type","title":"Runbox.Runtime.Stage.ComponentNetwork.subscription_properties/0","doc":"Additional properties of subscription/edge. E.g. selector for Broadcast dispatcher.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#t:subscription_properties/0"},{"type":"type","title":"Runbox.Runtime.Stage.ComponentNetwork.t/0","doc":"Component network is adjacency graph with subscription edges.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#t:t/0"},{"type":"module","title":"Runbox.Runtime.Stage.Sandbox","doc":"Sandbox is helper for executing runs without started Altworx application. Sandbox can be used for scenarios unit testing and also for interactive development of scenarios. When used for unit testing, it can be used directly or via Runbox.Runtime.Stage.Sandbox.TestRunner . For interactive development of scenarios, run iex --erl &quot;-runbox mode slave&quot; -S mix from command line in your scenarios application root directory and then use Sandbox fuctions to execute your runs (of course use recompile before run execution if you changed scenario code).","ref":"Runbox.Runtime.Stage.Sandbox.html"},{"type":"function","title":"Runbox.Runtime.Stage.Sandbox.execute_run/3","doc":"Starts new run for scenario_id and waits until all input messages are processed. Returns all output actions generated by run execution. Input messages for each runtime topic used by scenario should be defined in topics argument. Undefined topics are considered empty. Messages in each topic must be in ascending order by timestamp . There are few options that can be specified. :start_from - specify the start from value for the run. The value is used to filter out messages (as in a real run, input topics only use messages with timestamp &gt;= start_from ) and the value is provided to template's init callback. :modules - list of modules containing scenarios (manifests, templates). If list of modules is specified execute_run does not search scenario in :scenarios application release, but in given modules. It opens possibility to write ad-hoc scenarios with only dependency on Runbox application, for example use it in Livebook . To see example of such livebook just run livebook server --home . in runbox root directory, go to generated livebook server link in browser and finally open sandbox-scenario-demo.livemd document. Running docker or altworx is not needed, only runbox app (and its deps) is required!","ref":"Runbox.Runtime.Stage.Sandbox.html#execute_run/3"},{"type":"type","title":"Runbox.Runtime.Stage.Sandbox.topic_name/0","doc":"","ref":"Runbox.Runtime.Stage.Sandbox.html#t:topic_name/0"},{"type":"type","title":"Runbox.Runtime.Stage.Sandbox.topics/0","doc":"","ref":"Runbox.Runtime.Stage.Sandbox.html#t:topics/0"},{"type":"module","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe","doc":"Transform valid component network to gen_stage definitions.","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html"},{"type":"function","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe.component_name/1","doc":"","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html#component_name/1"},{"type":"function","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe.create/1","doc":"Transform valid component network to gen_stage definitions.","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html#create/1"},{"type":"type","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe.component/0","doc":"","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html#t:component/0"},{"type":"type","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe.component_network/0","doc":"","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html#t:component_network/0"},{"type":"type","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe.subscription/0","doc":"","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html#t:subscription/0"},{"type":"module","title":"Runbox.Runtime.Stage.Sandbox.TestRunner","doc":"For new unit testing of scenarios it is recommended to use functions in Runbox.Runtime.Stage.Sandbox directly. This module should only help to convert old scenarios integration tests (using Solutions.TestRunner) to unit tests. For examples of such conversion see tests in the scenarios master branch.","ref":"Runbox.Runtime.Stage.Sandbox.TestRunner.html"},{"type":"function","title":"Runbox.Runtime.Stage.Sandbox.TestRunner.run_test/1","doc":"Runs an unit test according to the test_def definition. Function accepts the same test_def definition as Solutions.TestRunner.run_test/1 with few differences: Only run_options.scenario_id , run_options.start_from , messages and expected_actions properties are used, other properties are ignored. Instead of output log format expected_actions are Runbox.Scenario.OutputAction structures, for example %{ action : :add_asset , params : %{ attributes : %{ } , id : &quot;/diamonds/O&quot; } , result : &quot;nil&quot; , serialization_vector : [ &quot;/diamonds/O&quot; ] , side_effects : false , timestamp : 1 } must be changed to: % Runbox.Scenario.OutputAction { body : % Runbox.Scenario.OutputAction.UpsertAssetAttributes { type : &quot;/diamonds&quot; , id : &quot;O&quot; , attributes : %{ } } , timestamp : 1 } To see differences take a look at deduplication_diamond_test.exs in scenarios and the same test in solutions.","ref":"Runbox.Runtime.Stage.Sandbox.TestRunner.html#run_test/1"},{"type":"module","title":"Runbox.Runtime.Stage.SelectorBuilder","doc":"Selector function generator which is used to filter messages between GenStage phases. Stage based runtime uses BroadcastDispatcher to dispatch messages between TemplateCarriers, this kind of dispatcher support message selector function to be passed as part of GenStage subscription. This module is used to generate this function based on template configuration.","ref":"Runbox.Runtime.Stage.SelectorBuilder.html"},{"type":"function","title":"Runbox.Runtime.Stage.SelectorBuilder.build/1","doc":"Builds GenStages BroadcastDispatcher filter function based on template configuration. Filter function is produced based on Runbox.Scenario.Template.StageBased.subscriptions/0 callback result. Subscription is defined as {message_type, _routing_rule}, we use only message_type part of subscription. All message types are stored in produced function clojure and dispatched message type is matched against them. Exception to the message type matching are output actions and tick messages which are always matched.","ref":"Runbox.Runtime.Stage.SelectorBuilder.html#build/1"},{"type":"module","title":"Runbox.Runtime.Stage.StateGenerator","doc":"Module generates state of run components running on slave node.","ref":"Runbox.Runtime.Stage.StateGenerator.html"},{"type":"function","title":"Runbox.Runtime.Stage.StateGenerator.generate_for_component/2","doc":"Generates state for component template.","ref":"Runbox.Runtime.Stage.StateGenerator.html#generate_for_component/2"},{"type":"module","title":"Runbox.Runtime.Stage.TemplateCarrier","doc":"Module implements producer_consumer GenStage behaviour, scenario template is used to handle events Every scenario template is represented in stage based runtime by this module. TemplateCarrier uses Runbox.Runtime.Stage.UnitRegistry as its state (packed in Runbox.StateStore.Entity envelope for StateStore usage). UnitRegistry provides functionality to lookup units via subscriptions defined in scenario template. If unit is located for given message, Runbox.Scenario.Template.StageBased.handle_message/2 is used to handle this message. When there is no registered unit for given routing key, Runbox.Scenario.Template.StageBased.handle_asset_discovery/1 is used instead. The state is updated in Runbox.StateStore.Entity with Runbox.StateStore.Entity.update_state/3 after every message is processed. Additionally, before a message is processed it is confirmed that all messages with lower timestamps were processed. This is done with Runbox.StateStore.Entity.ack_processed_time/3 and can result in saving the state in state store.","ref":"Runbox.Runtime.Stage.TemplateCarrier.html"},{"type":"function","title":"Runbox.Runtime.Stage.TemplateCarrier.component_name/1","doc":"","ref":"Runbox.Runtime.Stage.TemplateCarrier.html#component_name/1"},{"type":"function","title":"Runbox.Runtime.Stage.TemplateCarrier.start_link/3","doc":"","ref":"Runbox.Runtime.Stage.TemplateCarrier.html#start_link/3"},{"type":"module","title":"Runbox.Runtime.Stage.TemplateImpl","doc":"Module encapsulates scenario template callback calls. Scenario defines Toolbox.Runtime.Stage.Unit as state carrier, these units are organized into Runbox.Runtime.Stage.UnitRegistry which is helper structure to route messages between units managed by one template. Messages are handled via Runbox.Scenario.Template.StageBased callbacks. We distinguish two types of messages = message to existing unit and message to new unit (asset discovery). Messages that doesn't have any unit registered and thus found to handle them, we call this situation asset discovery and use Runbox.Scenario.Template.StageBased.handle_asset_discovery/1 callback to handle these message. New unit may or may not be created here, but when it does, it needs to be initialized via Runbox.Scenario.Template.StageBased.init/2 callback. When there is at least one unit which is registered to the message, we use callback Runbox.Scenario.Template.StageBased.handle_message/2 . Unit may be updated or stopped here. We support timeouts to be defined. These timeouts are triggered via external time, which is derived from incomming message timestamps. Timeouts are registered for one unit. Some output actions produced by any of template callback should be further updated. Events require filling run id and notifications require scenario id to be filled.","ref":"Runbox.Runtime.Stage.TemplateImpl.html"},{"type":"function","title":"Runbox.Runtime.Stage.TemplateImpl.handle_message/6","doc":"","ref":"Runbox.Runtime.Stage.TemplateImpl.html#handle_message/6"},{"type":"function","title":"Runbox.Runtime.Stage.TemplateImpl.init_state/5","doc":"","ref":"Runbox.Runtime.Stage.TemplateImpl.html#init_state/5"},{"type":"module","title":"Runbox.Runtime.Stage.Timezip","doc":"Timezip component responsible for merging messages from multiple sources using message timestamps.","ref":"Runbox.Runtime.Stage.Timezip.html"},{"type":"function","title":"Runbox.Runtime.Stage.Timezip.component_name/1","doc":"","ref":"Runbox.Runtime.Stage.Timezip.html#component_name/1"},{"type":"function","title":"Runbox.Runtime.Stage.Timezip.start_link/3","doc":"","ref":"Runbox.Runtime.Stage.Timezip.html#start_link/3"},{"type":"module","title":"Runbox.Runtime.Stage.Timezip.MultiQueue","doc":"Buffering multi-queue data structure for Timezip. If the structure would be heap, the complexity would be Olog(N) where N is number of messages (topped by max demand). With multi-queue operation is ~ O(M) where M is number of producers.","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html"},{"type":"function","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.add_queue/2","doc":"Adds new queue to MultiQueue. If adding same id again -&gt; clears buffered messages for given producer.","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#add_queue/2"},{"type":"function","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.dequeue_all/2","doc":"Main logic, will return messages from all queues zipped/sorted by min timestamp. Will return as many messages as posible, until some queue is empty. In returned tuple, returned values means: multi_queue: multi-queue without emitted messages demand_distribution: map with id -&gt; integer() , meaning how many messages in output originates from particular queue id, can be used for manual demand handling in genstage emitted: returned messages from multiqueue front","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#dequeue_all/2"},{"type":"function","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.enqueue/3","doc":"Adds messages for queue id to multiqueue.","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#enqueue/3"},{"type":"function","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.new/0","doc":"","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#new/0"},{"type":"function","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.remove_queue/2","doc":"Removes queue and its content from multi_queue","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#remove_queue/2"},{"type":"type","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.demand_distribution/0","doc":"","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#t:demand_distribution/0"},{"type":"type","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.t/0","doc":"","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#t:t/0"},{"type":"module","title":"Runbox.Runtime.Stage.UnitRegistry","doc":"Unit register used in stage based runtime to manage state of units. UnitRegistry is configured via Runbox.Scenario.Template.StageBased.subscriptions/0 callback result. Callback returns template subscriptions, each subscription is defined as {message_type, routing_rule}. Unit registry contains one register per configured message_type. Routing rule is used to store unit and later on lookup this unit when needed. Units are being registered using unit attributes as defined in routing_rule. Unit lookup uses routing_rule to parse message body and the result compares to stored unit attributes.","ref":"Runbox.Runtime.Stage.UnitRegistry.html"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.get_unit/2","doc":"Returns unit with given id.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#get_unit/2"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.init/1","doc":"Initialize UnitRegistry non-persisted fields. This needs to be called right before starting new unit registry (done in new/1 automatically) and also after loading UnitRegistry from savepoint. This is needed because not all fields are persisted into a savepoint.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#init/1"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.lookup/2","doc":"Searches for registered unit in the unit registry.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#lookup/2"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.new/1","doc":"Creates new unit registry.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#new/1"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.pop_reached_timeout/2","doc":"Returns first reached timeout and removes it from unit registry in one operation.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#pop_reached_timeout/2"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.register/2","doc":"Registers given unit to the unit registry.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#register/2"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.register_timeout/4","doc":"Registers timeout.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#register_timeout/4"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.reregister/2","doc":"Reregisters unit in the unit registry. Function updates alternative registers using new version of unit attributes. Timeouts will remain untouched.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#reregister/2"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.unregister/2","doc":"Unregisters given unit from the unit registry.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#unregister/2"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.update/2","doc":"Updates unit in unit registry.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#update/2"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.msg_parser/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:msg_parser/0"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.path/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:path/0"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.routing_key/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:routing_key/0"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.routing_key_def/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:routing_key_def/0"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.t/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:t/0"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.unit_id/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:unit_id/0"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.unit_register/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:unit_register/0"},{"type":"module","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry","doc":"Module manages alternative registry state. Every unit is registered only once per alternative registry. More than one unit can be registered with the same key.","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.lookup/2","doc":"Get registered unit ids","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#lookup/2"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.new/0","doc":"Returns new alternative registry","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#new/0"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.register_unit/3","doc":"Registers unit in alternative reg with given key","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#register_unit/3"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.unregister_unit/2","doc":"Unregisters unit from alternative reg","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#unregister_unit/2"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.registration_key/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#t:registration_key/0"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.t/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#t:t/0"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.unit_id/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#t:unit_id/0"},{"type":"module","title":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder","doc":"Builder of msg_parser and unit_register fns used in Runbox.Runtime.Stage.UnitRegistry message_parser is lambda function used to parse Toolbox.Message and creates key to find unit in unit registry unit_register is lambda function used to parse Toolbox.Runtime.Stage.Unit and creates key to store unit in unit registry","ref":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder.html"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder.build_msg_parser/1","doc":"Gets routing key definition as argument and returns msg_parser lambda function Lambda takes Toolbox.Message as argument and returns list of message body values based on provided routing key definition. iex&gt; msg_parser_fn = ...&gt; RoutingKeyBuilder.build_msg_parser({:=, [[:foo]], [[:bar]]}) ...&gt; msg_parser_fn.(%Message{body: %{foo: &quot;message_body_key_value&quot;}}) [&quot;message_body_key_value&quot;] iex&gt; msg_parser_fn = ...&gt; RoutingKeyBuilder.build_msg_parser({:in, [[:foo]], [[:bar]]}) ...&gt; msg_parser_fn.(%Message{body: %{foo: &quot;message_body_key_value&quot;}}) [&quot;message_body_key_value&quot;]","ref":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder.html#build_msg_parser/1"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder.build_unit_register/1","doc":"Gets routing key definition as argument and returns unit_register lambda function Lambda takes alternative registers (unit indexes), alternative register name, Toolbox.Runtime.Stage.Unit as arguments and returns updated alternative registers based on provided routing key definition. iex&gt; unit_register_fn = ...&gt; RoutingKeyBuilder.build_unit_register({:=, [[:foo]], [[:bar]]}) ...&gt; unit = %Unit{id: &quot;unit_id&quot;, attributes: %{bar: &quot;attribute_key_value&quot;}} ...&gt; unit_register_fn.(%{&quot;alt_reg&quot; =&gt; AlternativeRegistry.new()}, &quot;alt_reg&quot;, unit) %{&quot;alt_reg&quot; =&gt; %{[&quot;attribute_key_value&quot;] =&gt; [&quot;unit_id&quot;]}} iex&gt; unit_register_fn = ...&gt; RoutingKeyBuilder.build_unit_register({:in, [[:foo]], [[:bar]]}) ...&gt; unit = %Unit{id: &quot;unit_id&quot;, attributes: %{bar: [&quot;value_1&quot;, &quot;value_2&quot;]}} ...&gt; unit_register_fn.(%{&quot;alt_reg&quot; =&gt; AlternativeRegistry.new()}, &quot;alt_reg&quot;, unit) %{&quot;alt_reg&quot; =&gt; %{[&quot;value_1&quot;] =&gt; [&quot;unit_id&quot;], [&quot;value_2&quot;] =&gt; [&quot;unit_id&quot;]}}","ref":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder.html#build_unit_register/1"},{"type":"module","title":"Runbox.Scenario","doc":"Holds information about scenario.","ref":"Runbox.Scenario.html"},{"type":"function","title":"Runbox.Scenario.get_impl_for/1","doc":"","ref":"Runbox.Scenario.html#get_impl_for/1"},{"type":"function","title":"Runbox.Scenario.manifest_module?/1","doc":"","ref":"Runbox.Scenario.html#manifest_module?/1"},{"type":"function","title":"Runbox.Scenario.template_module?/2","doc":"","ref":"Runbox.Scenario.html#template_module?/2"},{"type":"type","title":"Runbox.Scenario.component_def/0","doc":"","ref":"Runbox.Scenario.html#t:component_def/0"},{"type":"type","title":"Runbox.Scenario.t/0","doc":"","ref":"Runbox.Scenario.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.Asset","doc":"Utilities for working with Asset","ref":"Runbox.Scenario.Asset.html"},{"type":"function","title":"Runbox.Scenario.Asset.split_id/1","doc":"Split asset id by the last slash. Example iex&gt; Asset . split_id ( &quot;/type/id&quot; ) { &quot;/type&quot; , &quot;id&quot; } iex&gt; Asset . split_id ( &quot;id&quot; ) { &quot;&quot; , &quot;id&quot; }","ref":"Runbox.Scenario.Asset.html#split_id/1"},{"type":"module","title":"Runbox.Scenario.Config","doc":"Provides configuration to a scenario.","ref":"Runbox.Scenario.Config.html"},{"type":"function","title":"Runbox.Scenario.Config.read_file/2","doc":"Read file from the config dir. The file is located in the configuration directory, in a folder matching the scenario_id param. The file is read if it exists and content is returned as {:ok, content} , otherwise {:error, reason} is returned.","ref":"Runbox.Scenario.Config.html#read_file/2"},{"type":"function","title":"Runbox.Scenario.Config.resolve_file/2","doc":"Resolves a path to a file in scenario config. The file is located in the configuration directory, in a folder matching the scenario_id param. This function resolves the path so that it can be used with File functions directly. The existence of the file is not verified. Note if you want to just read the file, you can use read_file/2 , this function should be used when you need to handle the file in a special manner (e.g. streaming).","ref":"Runbox.Scenario.Config.html#resolve_file/2"},{"type":"module","title":"Runbox.Scenario.Helper","doc":"Support for helper processes for scenarios. Provides a supervisor and process registry under which scenarios can start their side-kick processes intended for housekeeping tasks.","ref":"Runbox.Scenario.Helper.html"},{"type":"function","title":"Runbox.Scenario.Helper.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Runbox.Scenario.Helper.html#child_spec/1"},{"type":"function","title":"Runbox.Scenario.Helper.start_link/1","doc":"Starts a supervisor with dynamic supervisor and process registry.","ref":"Runbox.Scenario.Helper.html#start_link/1"},{"type":"function","title":"Runbox.Scenario.Helper.via_registry/1","doc":"Returns a :via name to be used in the helper process registry.","ref":"Runbox.Scenario.Helper.html#via_registry/1"},{"type":"function","title":"Runbox.Scenario.Helper.with_helper/3","doc":"Executes a given callback over running helper. Checks whether the helper with name registered under helper registry is already running. If not, then it starts the process according to child_spec under the dynamic supervisor. In either case, it passes the helper process pid to the callback . It is the responsibility of the helper process to register its name with the helper registry via the via_registry/1 . Examples iex&gt; child_spec = %{ ...&gt; id : MyHelper , ...&gt; start : { ...&gt; Agent , ...&gt; :start_link , ...&gt; [ fn -&gt; 1 end , [ name : Helper . via_registry ( MyHelper ) ] ] ...&gt; } ...&gt; } iex&gt; :ok = Helper . with_helper ( MyHelper , child_spec , fn pid -&gt; Agent . update ( pid , &amp; &amp;1 + 1 ) end ) iex&gt; Helper . with_helper ( MyHelper , child_spec , fn pid -&gt; Agent . get ( pid , &amp; &amp;1 ) end ) 2","ref":"Runbox.Scenario.Helper.html#with_helper/3"},{"type":"behaviour","title":"Runbox.Scenario.Manifest","doc":"Behaviour and struct for scenario manifest.","ref":"Runbox.Scenario.Manifest.html"},{"type":"callback","title":"Runbox.Scenario.Manifest.get_info/0","doc":"Invoked to obtain the scenario manifest.","ref":"Runbox.Scenario.Manifest.html#c:get_info/0"},{"type":"callback","title":"Runbox.Scenario.Manifest.on_start/0","doc":"Invoked once when the scenario run starts. Useful for doing any necessary preparations for scenario run. Warning: Do not rely on any external resources (e.g. SQL queries) which may change the scenario logic. This callback is optional. If it is not implemented, no action is performed when starting the scenario run.","ref":"Runbox.Scenario.Manifest.html#c:on_start/0"},{"type":"type","title":"Runbox.Scenario.Manifest.attribute_detail/0","doc":"Assets group attributes metadata. Metadata helps the UI to render form for the group attributes definition. Attributes of the group are saved in asset attributes in Reality Network if group is materialized as asset in Reality Network. Properties :name - user-friendly attribute name - what is set. :description - longer attribute description - what the attribute does, the unit, ... :path - path to attribute in attributes JSON. :type - type of attribute value (helps the UI to render form input).","ref":"Runbox.Scenario.Manifest.html#t:attribute_detail/0"},{"type":"type","title":"Runbox.Scenario.Manifest.group_of_assets/0","doc":"Metadata (template) of assets group. The scenario should be able to carry a list of groups it uses. These groups can then be easily created in the UI by the user without having to fill in some information manually. Metadata defines these helpers for the UI. Properties :name - short name of group template for UI. :description - description of assets group. :asset_type - asset type of asset created by the group. :edge_type - edge type for connecting assets in the group. :edge_direction - edge direction (true = from group asset to assets in group). :attributes - description of group attributes.","ref":"Runbox.Scenario.Manifest.html#t:group_of_assets/0"},{"type":"type","title":"Runbox.Scenario.Manifest.t/0","doc":"","ref":"Runbox.Scenario.Manifest.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.Manifest.Incident","doc":"Struct representing incident manifest","ref":"Runbox.Scenario.Manifest.Incident.html"},{"type":"type","title":"Runbox.Scenario.Manifest.Incident.t/0","doc":"","ref":"Runbox.Scenario.Manifest.Incident.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.Manifest.IncidentFrame","doc":"Struct representing one column in incident forecast UI widget. Properties: :name displayed column name :since time frame start interval in ms :till time frame end interval in ms","ref":"Runbox.Scenario.Manifest.IncidentFrame.html"},{"type":"type","title":"Runbox.Scenario.Manifest.IncidentFrame.t/0","doc":"","ref":"Runbox.Scenario.Manifest.IncidentFrame.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.Notification","doc":"Module contains functions for working with scenario notifications.","ref":"Runbox.Scenario.Notification.html"},{"type":"function","title":"Runbox.Scenario.Notification.list_channels/3","doc":"Lists all channels with templates defined for scenario, notification type and template type.","ref":"Runbox.Scenario.Notification.html#list_channels/3"},{"type":"function","title":"Runbox.Scenario.Notification.list_languages/4","doc":"Lists all template languages defined for senario, notification type, template type and channel.","ref":"Runbox.Scenario.Notification.html#list_languages/4"},{"type":"function","title":"Runbox.Scenario.Notification.list_notification_types/1","doc":"Lists all notification types for a scenario.","ref":"Runbox.Scenario.Notification.html#list_notification_types/1"},{"type":"function","title":"Runbox.Scenario.Notification.list_template_types/2","doc":"Lists all template types of the specified notification.","ref":"Runbox.Scenario.Notification.html#list_template_types/2"},{"type":"function","title":"Runbox.Scenario.Notification.load_and_eval_templates/7","doc":"Loads and evaluates templates specified by scenario, notification type, template type, channel and language. If language is not defined or does not exist, fallback_language is used.","ref":"Runbox.Scenario.Notification.html#load_and_eval_templates/7"},{"type":"function","title":"Runbox.Scenario.Notification.load_spec/1","doc":"Tries to load the notification spec of the given scenario. Returns {:ok, notification_spec} if the spec is found {:error, :cannot_load, exception} if the spec file cannot be found {:error, :bad_syntax, exception} if the spec file was found but contains syntactic errors","ref":"Runbox.Scenario.Notification.html#load_spec/1"},{"type":"module","title":"Runbox.Scenario.OutputAction","doc":"Output action represents a side effect produced by a run. Creating output actions Creating output action typically happens from scenario. It is done by creating one of the appropriate struct: Runbox.Scenario.OutputAction.UpsertAssetAttributes.t/0 Runbox.Scenario.OutputAction.DeleteAssetAttributes.t/0 Runbox.Scenario.OutputAction.DeleteAllAssetAttributes.t/0 Runbox.Scenario.OutputAction.UpsertEdge.t/0 Runbox.Scenario.OutputAction.DeleteEdge.t/0 Runbox.Scenario.OutputAction.Notification.t/0 Runbox.Scenario.OutputAction.Event.t/0 Runbox.Scenario.OutputAction.ExecuteSQL.t/0 For example: iex&gt; % OutputAction.UpsertAssetAttributes { ...&gt; type : &quot;/asset/camera&quot; , ...&gt; id : &quot;one&quot; , ...&gt; attributes : %{ &quot;foo&quot; =&gt; &quot;bar&quot; } ...&gt; } Asset and edge output actions Changes done by output actions to assets and edges are scoped for each scenario run. The global result is computed from the changes done by individual runs. A single run is forbidden to do multiple changes to the same object (asset attribute or edge) at the same time. However distinct runs can perform such changes, because they are scoped to each run. The rules to compute the global state apply in the following order: Change with the higher timestamp has precedence. Updating an asset attribute or an edge has precedence to deleting it. Change with the higher value has precedence (applies only for asset attributes).","ref":"Runbox.Scenario.OutputAction.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.asset_id/0","doc":"","ref":"Runbox.Scenario.OutputAction.html#t:asset_id/0"},{"type":"type","title":"Runbox.Scenario.OutputAction.asset_type/0","doc":"","ref":"Runbox.Scenario.OutputAction.html#t:asset_type/0"},{"type":"type","title":"Runbox.Scenario.OutputAction.edge_type/0","doc":"","ref":"Runbox.Scenario.OutputAction.html#t:edge_type/0"},{"type":"type","title":"Runbox.Scenario.OutputAction.oa_params/0","doc":"","ref":"Runbox.Scenario.OutputAction.html#t:oa_params/0"},{"type":"type","title":"Runbox.Scenario.OutputAction.t/0","doc":"Output Action This struct is produced by Runbox.Runtime.Stage.Sandbox.execute_run/3 .","ref":"Runbox.Scenario.OutputAction.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.BadOutputAction","doc":"Body of invalid output action.","ref":"Runbox.Scenario.OutputAction.BadOutputAction.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.BadOutputAction.t/0","doc":"Bad Output Action :params - holds the original parameters","ref":"Runbox.Scenario.OutputAction.BadOutputAction.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.DeleteAllAssetAttributes","doc":"Parameters for output action Delete All Asset Attributes. The resulting output action will delete all existing attributes of the given asset. This is scoped to the attributes created by the same run.","ref":"Runbox.Scenario.OutputAction.DeleteAllAssetAttributes.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.DeleteAllAssetAttributes.t/0","doc":"Delete All Asset Attributes :type - asset type :id - asset ID","ref":"Runbox.Scenario.OutputAction.DeleteAllAssetAttributes.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.DeleteAssetAttributes","doc":"Parameters for output action Delete Asset Attributes. The resulting output action will delete attributes of the given asset. This action succeeds even if the attributes do not exist.","ref":"Runbox.Scenario.OutputAction.DeleteAssetAttributes.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.DeleteAssetAttributes.t/0","doc":"Delete Asset Attributes :type - asset type :id - asset ID :attributes - a map of attributes to be deleted The leaf attributes of the :attributes map are deleted. E.g., if asset has the following attributes %{ &quot;a&quot; : 1 , &quot;b&quot; : %{ &quot;c&quot; =&gt; 2 } } and the following :attributes are provided in the output action %{ &quot;b&quot; : %{ &quot;c&quot; =&gt; true } } then b.c attribute will be deleted, resulting in %{ &quot;a&quot; : 1 &quot;b&quot; : %{ } }","ref":"Runbox.Scenario.OutputAction.DeleteAssetAttributes.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.DeleteEdge","doc":"Parameters for output action Delete Edge. The resulting output action will delete an edge between two assets. This action succeeds even if the edge does not exist.","ref":"Runbox.Scenario.OutputAction.DeleteEdge.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.DeleteEdge.t/0","doc":"Delete Edge :from_type - type of the asset which this edge goes out from :from_id - id of the asset which this edge goes out from :to_type - type of the asset which this edge goes to :to_id - id of the asset which this edge goes to :type - type of the edge","ref":"Runbox.Scenario.OutputAction.DeleteEdge.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.Event","doc":"Parameters for output action Event. The resulting output action creates an event.","ref":"Runbox.Scenario.OutputAction.Event.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.Event.t/0","doc":"Event :type - type of the event. It's declared in Scenario's Manifest. :template - event's template. See AssetMap.Events.Template . :actors - map of actors which are interpolated in the template. :params - map of template params that are interpolated in the template. :origin_messages - list of raw messages linked with the event itself.","ref":"Runbox.Scenario.OutputAction.Event.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.ExecuteSQL","doc":"Parameters for output action Execute SQL. The resulting output action executes an SQL statement.","ref":"Runbox.Scenario.OutputAction.ExecuteSQL.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.ExecuteSQL.t/0","doc":"Execute SQL :db_connection - map with database connection info ( hostname , username , password , database ) :sql_query - SQL query. :data - list of parameterized data. :type - database type, right now only PostgreSQL is supported. It's checked in OutputProcessor and the value must be :postgresql . If :run_id is present in data , it's replaced with actual run_id in AssetMap.Api.SqlExecutor .","ref":"Runbox.Scenario.OutputAction.ExecuteSQL.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.Incident","doc":"Parameters for output action Incident. The resulting output action creates an incident.","ref":"Runbox.Scenario.OutputAction.Incident.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.Incident.severity/0","doc":"","ref":"Runbox.Scenario.OutputAction.Incident.html#t:severity/0"},{"type":"type","title":"Runbox.Scenario.OutputAction.Incident.t/0","doc":"Incident","ref":"Runbox.Scenario.OutputAction.Incident.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.IncidentActor","doc":"Incident Actor","ref":"Runbox.Scenario.OutputAction.IncidentActor.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.IncidentActor.t/0","doc":"","ref":"Runbox.Scenario.OutputAction.IncidentActor.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.IncidentFuture","doc":"Incident Future","ref":"Runbox.Scenario.OutputAction.IncidentFuture.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.IncidentFuture.t/0","doc":"","ref":"Runbox.Scenario.OutputAction.IncidentFuture.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.IncidentHistory","doc":"Incident History","ref":"Runbox.Scenario.OutputAction.IncidentHistory.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.IncidentHistory.t/0","doc":"","ref":"Runbox.Scenario.OutputAction.IncidentHistory.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.IncidentPatch","doc":"Parameters for output action Incident Patch. The resulting output action updates an incident.","ref":"Runbox.Scenario.OutputAction.IncidentPatch.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.IncidentPatch.t/0","doc":"Incident Patch","ref":"Runbox.Scenario.OutputAction.IncidentPatch.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.Notification","doc":"Parameters for output action Notification. The resulting output action sends a notification.","ref":"Runbox.Scenario.OutputAction.Notification.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.Notification.t/0","doc":"Notification :type - string, type of the notification :data - map, data for the template evaluation :primary_asset - string, optional, id of an asset that corresponds to this notification :ids - list of asset ids, optional, to filter recipients, each recipient must have sufficient privileges to see all listed IDs :aqls - map, AQLs which are evaluated, provide further context to the templates, and also can serve the same purpose as ids - filter recipients to only those who can see the whole result of the query. Key is the name of the AQL which can be used in the template. Value is a map with aql (the AQL query) and primary (whether the AQL should also be used to filter recipients) keys. :priority - optional, defaults to :medium , can be :low , :medium , :high , only applicable to some channels :metadata - map, optional, additional metadata which can be used in notification group subscriptions. Should adhere to the format specified in notification/spec.exs . :direct_subscriptions - list of maps, subscriptions to be used additionally to the usual routing. Each map should have the following. :user - map, user object to be used instead of Altworx object, should have notification.email and optionally even notification.language . :templates - list of ids, which templates should be used :channels - list of ids, which channels should be used :attachments - list of maps, optional, attachments that should be sent with the notification. Each map has the following keys. :data - binary, content of the attachment :filename - string, name of the file :content_type - string, optional, MIME type of the data :type - whether the attachment is to inlined in the template ( :inline ) or not ( :attachment , this is the default)","ref":"Runbox.Scenario.OutputAction.Notification.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.UpsertAssetAttributes","doc":"Parameters for output action Upsert Asset Attributes. The resulting output action will create or update attributes of the given asset.","ref":"Runbox.Scenario.OutputAction.UpsertAssetAttributes.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.UpsertAssetAttributes.t/0","doc":"Upsert Asset Attributes :type - asset type :id - asset ID :attributes - a map of attributes in format %{&quot;name&quot; =&gt; value} to be inserted or updated","ref":"Runbox.Scenario.OutputAction.UpsertAssetAttributes.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.UpsertEdge","doc":"Parameters for output action Upsert Edge. The resulting output action will create an edge between two assets. The assets do not have to exist at the time of the edge creation.","ref":"Runbox.Scenario.OutputAction.UpsertEdge.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.UpsertEdge.t/0","doc":"Upsert Edge :from_type - type of the asset which this edge goes out from :from_id - id of the asset which this edge goes out from :to_type - type of the asset which this edge goes to :to_id - id of the asset which this edge goes to :type - type of the edge","ref":"Runbox.Scenario.OutputAction.UpsertEdge.html#t:t/0"},{"type":"behaviour","title":"Runbox.Scenario.Template.StageBased","doc":"Module defines behaviour used in scenarios as template. Scenario template implementations are main components of scenario. Runtime uses callbacks of this behaviour to start scenario in run and to handle incomming messages. Each template behaviour implementation is represented as separate process in runtime called TemplateCarrier . Template is inteded to be used to model behaviour of assets of single type per template. Individual asset states are represented as Toolbox.Runtime.Stage.Unit.t/0 . Initial assets are defined via Runbox.Scenario.Template.StageBased.instances/0 callback. This callback should return list of unit definitions ( Runbox.Scenario.Template.StageBased.instances_def/0 ). Templates are linked together via subscriptions provided by callback Runbox.Scenario.Template.StageBased.subscriptions/0 . Subscription is defined as tuple containing component definition and routing rule list. It is possible to subscribe to other templates, input and load topics. Routing rules are used to locate units when message is handled. When routing rule succeeds, callback Runbox.Scenario.Template.StageBased.handle_message/2 is called, when routing rule fails to locat existing unit, Runbox.Scenario.Template.StageBased.handle_asset_discovery/1 gets called instead. Unit initialization can produce side effects via Runbox.Scenario.Template.StageBased.init/2 callback. This callback is triggered when instances are produced by Runbox.Scenario.Template.StageBased.instances/0 or Runbox.Scenario.Template.StageBased.handle_asset_discovery/1 callbacks. Units are already registered in the time when this callback is triggered, so changes in unit attributes won't change unit registration (defined by Runbox.Scenario.Template.StageBased.subscriptions/0 ). When message from subscribed publisher is handled by the TemplateCarrier , runtime tries to locate asset unit using given subscription configuration. If there is such a unit, runtime calls Runbox.Scenario.Template.StageBased.handle_message/2 callback and uses message and located message as attributes. In case that no unit was found, Runbox.Scenario.Template.StageBased.handle_asset_discovery/1 gets called instead.","ref":"Runbox.Scenario.Template.StageBased.html"},{"type":"callback","title":"Runbox.Scenario.Template.StageBased.handle_asset_discovery/1","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#c:handle_asset_discovery/1"},{"type":"function","title":"Runbox.Scenario.Template.StageBased.handle_asset_discovery/2","doc":"Invokes template_module.asset_discovery with given message .","ref":"Runbox.Scenario.Template.StageBased.html#handle_asset_discovery/2"},{"type":"callback","title":"Runbox.Scenario.Template.StageBased.handle_message/2","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#c:handle_message/2"},{"type":"function","title":"Runbox.Scenario.Template.StageBased.handle_message/3","doc":"Invokes template_module.handle_message with given message and unit .","ref":"Runbox.Scenario.Template.StageBased.html#handle_message/3"},{"type":"callback","title":"Runbox.Scenario.Template.StageBased.init/2","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#c:init/2"},{"type":"function","title":"Runbox.Scenario.Template.StageBased.init/3","doc":"Updates unit and sets initial unit state.","ref":"Runbox.Scenario.Template.StageBased.html#init/3"},{"type":"callback","title":"Runbox.Scenario.Template.StageBased.instances/0","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#c:instances/0"},{"type":"function","title":"Runbox.Scenario.Template.StageBased.instances/1","doc":"Returns list of of asset units.","ref":"Runbox.Scenario.Template.StageBased.html#instances/1"},{"type":"callback","title":"Runbox.Scenario.Template.StageBased.subscriptions/0","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#c:subscriptions/0"},{"type":"function","title":"Runbox.Scenario.Template.StageBased.subscriptions/1","doc":"Returns subscriptions defined in template_module .","ref":"Runbox.Scenario.Template.StageBased.html#subscriptions/1"},{"type":"type","title":"Runbox.Scenario.Template.StageBased.handle_asset_discovery_resp/0","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#t:handle_asset_discovery_resp/0"},{"type":"type","title":"Runbox.Scenario.Template.StageBased.handle_message_resp/0","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#t:handle_message_resp/0"},{"type":"type","title":"Runbox.Scenario.Template.StageBased.instances_def/0","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#t:instances_def/0"},{"type":"type","title":"Runbox.Scenario.Template.StageBased.routing_key_definition/0","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#t:routing_key_definition/0"},{"type":"type","title":"Runbox.Scenario.Template.StageBased.subscription_def/0","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#t:subscription_def/0"},{"type":"type","title":"Runbox.Scenario.Template.StageBased.template_output/0","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#t:template_output/0"},{"type":"behaviour","title":"Runbox.Scenario.TemplateInspector","doc":"Behaviour used to detect scenario template source files.","ref":"Runbox.Scenario.TemplateInspector.html"},{"type":"callback","title":"Runbox.Scenario.TemplateInspector.template_info/1","doc":"","ref":"Runbox.Scenario.TemplateInspector.html#c:template_info/1"},{"type":"function","title":"Runbox.Scenario.TemplateInspector.template_info/2","doc":"Retrieve implementation specific information about a template.","ref":"Runbox.Scenario.TemplateInspector.html#template_info/2"},{"type":"callback","title":"Runbox.Scenario.TemplateInspector.valid_template?/1","doc":"","ref":"Runbox.Scenario.TemplateInspector.html#c:valid_template?/1"},{"type":"function","title":"Runbox.Scenario.TemplateInspector.valid_template?/2","doc":"Validate whether given module is valid template source file.","ref":"Runbox.Scenario.TemplateInspector.html#valid_template?/2"},{"type":"module","title":"Runbox.Scenario.UIAction","doc":"Definition of action to be fired from UI. In scenario list of Runbox.Scenario.UIAction s is defined and stored in asset map entity. When action is fired from UI, scenario receives Toolbox.Scenario.UserAction .","ref":"Runbox.Scenario.UIAction.html"},{"type":"function","title":"Runbox.Scenario.UIAction.actions/1","doc":"Converts list of UI actions to actions property. Map in resulting list contains two properties: action - action ( topic , type , details ) encoded to JWT. meta - metadata ( name , description ) to be used in UI. Resulting list of maps should be stored to some entity in asset map.","ref":"Runbox.Scenario.UIAction.html#actions/1"},{"type":"type","title":"Runbox.Scenario.UIAction.t/0","doc":"UI action definition. Properties topic , type and details are serialized to JWT token and used for routing of fired action. Property topic is name of raw topic where fired actions are pushed, property type is type to be used in Toolbox.Message as type and property details is stored in resulting message body as details property. Properties name and description are only metadata for UI.","ref":"Runbox.Scenario.UIAction.html#t:t/0"},{"type":"module","title":"Runbox.ScenarioRelease","doc":"Module for inspecting a scenario release.","ref":"Runbox.ScenarioRelease.html"},{"type":"function","title":"Runbox.ScenarioRelease.release_info/1","doc":"Retrieves information about scenarios in a release.","ref":"Runbox.ScenarioRelease.html#release_info/1"},{"type":"module","title":"Runbox.ScenarioRelease.SlaveFunc","doc":"Functions which are called on the scenario slave via RPC from the master node.","ref":"Runbox.ScenarioRelease.SlaveFunc.html"},{"type":"function","title":"Runbox.ScenarioRelease.SlaveFunc.release_info/1","doc":"","ref":"Runbox.ScenarioRelease.SlaveFunc.html#release_info/1"},{"type":"function","title":"Runbox.ScenarioRelease.SlaveFunc.scenarios/0","doc":"Returns list of scenarios in release.","ref":"Runbox.ScenarioRelease.SlaveFunc.html#scenarios/0"},{"type":"module","title":"Runbox.ScenarioTemplate","doc":"Holds information about scenario template.","ref":"Runbox.ScenarioTemplate.html"},{"type":"type","title":"Runbox.ScenarioTemplate.t/0","doc":"","ref":"Runbox.ScenarioTemplate.html#t:t/0"},{"type":"module","title":"Runbox.Slave","doc":"Utilities for starting a slave node with a scenario release and communicating with the node.","ref":"Runbox.Slave.html"},{"type":"function","title":"Runbox.Slave.call/4","doc":"Calls a function on the slave. Calls MFA on the slave . See :erpc.call/4 for details.","ref":"Runbox.Slave.html#call/4"},{"type":"function","title":"Runbox.Slave.start/2","doc":"Starts a slave node. The release_dir is a directory with scenario release. If app_env is set, given app environment variables are set on slave.","ref":"Runbox.Slave.html#start/2"},{"type":"function","title":"Runbox.Slave.with_slave/2","doc":"Spawns a slave and executes the fun . fun recives the slave node as a parameter. The slave is terminated after the fun finishes.","ref":"Runbox.Slave.html#with_slave/2"},{"type":"module","title":"Runbox.StateStore.Entity","doc":"Module defines struct which acts as state store envelope for any stateful runtime component.","ref":"Runbox.StateStore.Entity.html"},{"type":"function","title":"Runbox.StateStore.Entity.ack_processed_time/3","doc":"Confirm that all messages with lower timestamps were processed. When the timestamp is higher than next savepoint the state is persisted into StateStore with StateStore.save/4 and next savepoint target is determined and stored in the entity. The state is persisted only once per every savepoint.","ref":"Runbox.StateStore.Entity.html#ack_processed_time/3"},{"type":"function","title":"Runbox.StateStore.Entity.id/1","doc":"Returns entity id","ref":"Runbox.StateStore.Entity.html#id/1"},{"type":"function","title":"Runbox.StateStore.Entity.new/5","doc":"Creates new state store entity","ref":"Runbox.StateStore.Entity.html#new/5"},{"type":"function","title":"Runbox.StateStore.Entity.schedule/1","doc":"Returns entity schedule","ref":"Runbox.StateStore.Entity.html#schedule/1"},{"type":"function","title":"Runbox.StateStore.Entity.state/1","doc":"Returns entity state","ref":"Runbox.StateStore.Entity.html#state/1"},{"type":"function","title":"Runbox.StateStore.Entity.timestamp/1","doc":"Returns entity timestamp","ref":"Runbox.StateStore.Entity.html#timestamp/1"},{"type":"function","title":"Runbox.StateStore.Entity.update_state/3","doc":"Set entity state at the specified point in time.","ref":"Runbox.StateStore.Entity.html#update_state/3"},{"type":"type","title":"Runbox.StateStore.Entity.id/0","doc":"","ref":"Runbox.StateStore.Entity.html#t:id/0"},{"type":"type","title":"Runbox.StateStore.Entity.state/0","doc":"","ref":"Runbox.StateStore.Entity.html#t:state/0"},{"type":"type","title":"Runbox.StateStore.Entity.t/0","doc":"","ref":"Runbox.StateStore.Entity.html#t:t/0"},{"type":"module","title":"Runbox.StateStore.ScheduleUtils","doc":"Module contains functions to compute savepoint timestamps. Savepoint timestamps are calculated as multiples of schedule .","ref":"Runbox.StateStore.ScheduleUtils.html"},{"type":"function","title":"Runbox.StateStore.ScheduleUtils.next_savepoint/2","doc":"Returns next savepoint based on given schedule and timestamp . Next savepoint is calculated as next multiple of schedule larger or equal to given timestamp . Examples iex&gt; Runbox.StateStore.ScheduleUtils . next_savepoint ( 60_000 , 0 ) 60_000 iex&gt; Runbox.StateStore.ScheduleUtils . next_savepoint ( 60_000 , 10_000 ) 60_000 iex&gt; Runbox.StateStore.ScheduleUtils . next_savepoint ( 60_000 , 60_000 ) 120_000","ref":"Runbox.StateStore.ScheduleUtils.html#next_savepoint/2"},{"type":"function","title":"Runbox.StateStore.ScheduleUtils.previous_savepoint/2","doc":"Returns previous savepoint based on given schedule and timestamp . Next savepoint is calculated as previous multiple of schedule lower or equal to given timestamp . Examples iex&gt; Runbox.StateStore.ScheduleUtils . previous_savepoint ( 60_000 , 30_000 ) 0 iex&gt; Runbox.StateStore.ScheduleUtils . previous_savepoint ( 60_000 , 60_000 ) 60_000 iex&gt; Runbox.StateStore.ScheduleUtils . previous_savepoint ( 60_000 , 90_000 ) 60_000 iex&gt; Runbox.StateStore.ScheduleUtils . previous_savepoint ( 60_000 , 120_000 ) 120_000 iex&gt; Runbox.StateStore.ScheduleUtils . previous_savepoint ( 60_000 , 150_000 ) 120_000","ref":"Runbox.StateStore.ScheduleUtils.html#previous_savepoint/2"},{"type":"function","title":"Runbox.StateStore.ScheduleUtils.unreached_savepoints/3","doc":"Returns unreached savepoints based on given schedule in range of given timestamps (from; to&gt; Examples iex&gt; Runbox.StateStore.ScheduleUtils . unreached_savepoints ( 60_000 , 0 , 120_000 ) [ 60_000 , 120_000 ] iex&gt; Runbox.StateStore.ScheduleUtils . unreached_savepoints ( 60_000 , 60_000 , 120_000 ) [ 120_000 ] iex&gt; Runbox.StateStore.ScheduleUtils . unreached_savepoints ( 60_000 , 60_000 , 180_000 ) [ 120_000 , 180_000 ]","ref":"Runbox.StateStore.ScheduleUtils.html#unreached_savepoints/3"},{"type":"function","title":"Runbox.StateStore.ScheduleUtils.unreached_savepoints_count/3","doc":"Returns count of unreached savepoints. Examples iex&gt; Runbox.StateStore.ScheduleUtils . unreached_savepoints_count ( 60_000 , 0 , 120_000 ) 2 iex&gt; Runbox.StateStore.ScheduleUtils . unreached_savepoints_count ( 60_000 , 60_000 , 120_000 ) 1 iex&gt; Runbox.StateStore.ScheduleUtils . unreached_savepoints_count ( 1 , 0 , 120_000 ) 120_000","ref":"Runbox.StateStore.ScheduleUtils.html#unreached_savepoints_count/3"},{"type":"type","title":"Runbox.StateStore.ScheduleUtils.epoch_ms/0","doc":"Timestamp defined as unix epoch in milliseconds","ref":"Runbox.StateStore.ScheduleUtils.html#t:epoch_ms/0"},{"type":"type","title":"Runbox.StateStore.ScheduleUtils.epoch_ms_interval/0","doc":"Difference between two unix epoch timestamps in milliseconds","ref":"Runbox.StateStore.ScheduleUtils.html#t:epoch_ms_interval/0"},{"type":"type","title":"Runbox.StateStore.ScheduleUtils.schedule/0","doc":"Interval (in seconds) between savepoint timestamps.","ref":"Runbox.StateStore.ScheduleUtils.html#t:schedule/0"},{"type":"module","title":"Runbox.Utils.Enum","doc":"A set of utility functions for Enums.","ref":"Runbox.Utils.Enum.html"},{"type":"function","title":"Runbox.Utils.Enum.each_while_ok/2","doc":"Returns :ok if fun applied to every element of enumerable returns :ok . Otherwise it returns the first error occurred during fun call. Example iex&gt; each_while_ok ( [ ] , fn _ -&gt; :not_called_at_all end ) :ok iex&gt; each_while_ok ( [ 1 , 2 , 3 ] , fn _ -&gt; :ok end ) :ok iex&gt; each_while_ok ( [ 1 , 2 , 3 ] , &amp; ( if &amp;1 == 2 , do : { :error , &amp;1 } , else : :ok ) ) { :error , 2 }","ref":"Runbox.Utils.Enum.html#each_while_ok/2"},{"type":"function","title":"Runbox.Utils.Enum.map_while_ok/2","doc":"Returns {:ok, list_of_values} if fun applied to every element of enumerable returns {:ok, value} . Otherwise it returns the first error occurred during fun call. Example iex&gt; map_while_ok ( [ ] , fn _ -&gt; :not_called_at_all end ) { :ok , [ ] } iex&gt; map_while_ok ( [ 1 , 2 , 3 ] , &amp; ( { :ok , &amp;1 * 2 } ) ) { :ok , [ 2 , 4 , 6 ] } iex&gt; map_while_ok ( [ 1 , 2 , 3 ] , &amp; ( if &amp;1 == 2 , do : { :error , &amp;1 * 2 } , else : { :ok , &amp;1 * 2 } ) ) { :error , 4 }","ref":"Runbox.Utils.Enum.html#map_while_ok/2"},{"type":"function","title":"Runbox.Utils.Enum.reduce_while_ok/3","doc":"Invokes fun for each element in the enumerable with the accumulator. If every fun call returns {:ok, new_acc} , functions returns {:ok, last_acc} . Otherwise it returns the first error occurred during fun call. Example iex&gt; reduce_while_ok ( [ ] , :initial , fn _ , _ -&gt; :not_called_at_all end ) { :ok , :initial } iex&gt; reduce_while_ok ( [ 1 , 2 , 3 ] , 0 , &amp; ( { :ok , &amp;1 + &amp;2 } ) ) { :ok , 6 } iex&gt; reduce_while_ok ( [ 1 , 2 , 3 ] , 0 , &amp; ( if &amp;1 == 2 , do : { :error , &amp;1 + &amp;2 } , else : { :ok , &amp;1 + &amp;2 } ) ) { :error , 3 }","ref":"Runbox.Utils.Enum.html#reduce_while_ok/3"},{"type":"module","title":"Runbox.Utils.Map","doc":"A set of utility functions for Maps.","ref":"Runbox.Utils.Map.html"},{"type":"function","title":"Runbox.Utils.Map.get_path/3","doc":"Follows the path in the (deep) map, defaulting to default if some of the objects on the path is missing. Example iex&gt; object = %{ &quot;some&quot; =&gt; %{ &quot;deep&quot; =&gt; %{ &quot;object&quot; =&gt; &quot;data&quot; } } } ...&gt; Runbox.Utils.Map . get_path ( object , [ &quot;some&quot; , &quot;deep&quot; , &quot;object&quot; ] ) &quot;data&quot; iex&gt; Runbox.Utils.Map . get_path ( object , [ &quot;non-existent&quot; ] , &quot;default&quot; ) &quot;default&quot;","ref":"Runbox.Utils.Map.html#get_path/3"},{"type":"module","title":"Runbox.Utils.Path","doc":"Utilities for handling configured paths.","ref":"Runbox.Utils.Path.html"},{"type":"function","title":"Runbox.Utils.Path.get_altworx_root/0","doc":"Gets the Altworx root dir.","ref":"Runbox.Utils.Path.html#get_altworx_root/0"},{"type":"function","title":"Runbox.Utils.Path.resolve_path/1","doc":"Resolves a possibly relative path to absolute path by prepending the Altworx root dir (see set_altworx_root/1 ). Examples iex&gt; Path . set_altworx_root ( &quot;/opt/altworx&quot; ) :ok iex&gt; Path . resolve_path ( &quot;/already/absolute/path&quot; ) &quot;/already/absolute/path&quot; iex&gt; Path . resolve_path ( &quot;some/../relative/path&quot; ) &quot;/opt/altworx/relative/path&quot;","ref":"Runbox.Utils.Path.html#resolve_path/1"},{"type":"function","title":"Runbox.Utils.Path.set_altworx_root/1","doc":"Sets where the Altworx root dir is. Configuration and data dirs are supposed to be relative to the root dir. It is typically the directory which the VM is started in.","ref":"Runbox.Utils.Path.html#set_altworx_root/1"},{"type":"module","title":"Toolbox.ErrorMessage","doc":"Dead-letter message produced when evaluating of raw-topic failed.","ref":"Toolbox.ErrorMessage.html"},{"type":"type","title":"Toolbox.ErrorMessage.t/0","doc":"","ref":"Toolbox.ErrorMessage.html#t:t/0"},{"type":"module","title":"Toolbox.JitterMessage","doc":"Formerly delayed messages/late events, when jitter around incoming topic is out of threshold. Negative delay means message is too late (from past). Positive delay means message is too early (from future). Normalized messages is provided.","ref":"Toolbox.JitterMessage.html"},{"type":"type","title":"Toolbox.JitterMessage.t/0","doc":"See module Toolbox.JitterMessage info.","ref":"Toolbox.JitterMessage.html#t:t/0"},{"type":"module","title":"Toolbox.Message","doc":"Altworx message runtime representation.","ref":"Toolbox.Message.html"},{"type":"function","title":"Toolbox.Message.body/1","doc":"","ref":"Toolbox.Message.html#body/1"},{"type":"function","title":"Toolbox.Message.from/1","doc":"","ref":"Toolbox.Message.html#from/1"},{"type":"function","title":"Toolbox.Message.new/4","doc":"","ref":"Toolbox.Message.html#new/4"},{"type":"function","title":"Toolbox.Message.timestamp/1","doc":"","ref":"Toolbox.Message.html#timestamp/1"},{"type":"function","title":"Toolbox.Message.type/1","doc":"","ref":"Toolbox.Message.html#type/1"},{"type":"type","title":"Toolbox.Message.body/0","doc":"","ref":"Toolbox.Message.html#t:body/0"},{"type":"type","title":"Toolbox.Message.from/0","doc":"","ref":"Toolbox.Message.html#t:from/0"},{"type":"type","title":"Toolbox.Message.origin/0","doc":"","ref":"Toolbox.Message.html#t:origin/0"},{"type":"type","title":"Toolbox.Message.t/0","doc":"","ref":"Toolbox.Message.html#t:t/0"},{"type":"type","title":"Toolbox.Message.timestamp/0","doc":"","ref":"Toolbox.Message.html#t:timestamp/0"},{"type":"type","title":"Toolbox.Message.type/0","doc":"","ref":"Toolbox.Message.html#t:type/0"},{"type":"module","title":"Toolbox.Runtime.Stage.Unit","doc":"Struct representing a unit.","ref":"Toolbox.Runtime.Stage.Unit.html"},{"type":"function","title":"Toolbox.Runtime.Stage.Unit.attributes/1","doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#attributes/1"},{"type":"function","title":"Toolbox.Runtime.Stage.Unit.id/1","doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#id/1"},{"type":"function","title":"Toolbox.Runtime.Stage.Unit.new/3","doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#new/3"},{"type":"function","title":"Toolbox.Runtime.Stage.Unit.set_state/2","doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#set_state/2"},{"type":"function","title":"Toolbox.Runtime.Stage.Unit.state/1","doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#state/1"},{"type":"type","title":"Toolbox.Runtime.Stage.Unit.t/0","doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#t:t/0"},{"type":"module","title":"Toolbox.Scenario.UserAction","doc":"Toolbox for working with scenario user actions. User action is action created by scenario via Runbox.Scenario.UIAction and fired by user (usually from UI). Scenario is usually also a receiver of fired action. Assumed workflow is following: Scenario creates list of actions (using Runbox.Scenario.UIAction ) to be fired in the future and saves it somewhere (in incident asset for example). UI displays available actions. User fires selected action from UI. UI pushes the action to raw Kafka topic (defined in action) with extra data attached (usually some comment). Normalizer pipeline recieves the action and sends it to target scenario.","ref":"Toolbox.Scenario.UserAction.html"},{"type":"function","title":"Toolbox.Scenario.UserAction.fire/3","doc":"Unpacks action and makes it fired (prepared for sending to target topic). Routing properties ( type , details ) are propagated from packed action, user and data properties are attached to fired action. Target topic is also extracted from packed action. Returns error if packed action (JWT) is not valid.","ref":"Toolbox.Scenario.UserAction.html#fire/3"},{"type":"function","title":"Toolbox.Scenario.UserAction.normalizer_pipeline_step/1","doc":"Helper for UserAction forwading to be used in normalizer. If helper is used in normalizer pipeline configuration in config.ini like [ pipelines . some_pipeline ] definition = Toolbox.Scenario.UserAction . normalizer_pipeline_step than Toolbox.Message body will contain fired Toolbox.Scenario.UserAction .","ref":"Toolbox.Scenario.UserAction.html#normalizer_pipeline_step/1"},{"type":"function","title":"Toolbox.Scenario.UserAction.pack/3","doc":"Packs user action to JWT to be used (fired) later (from UI for example). Parameter details must be a map encodable to JSON. Because details can be (and it is!) encoded/decoded to/from JSON during its life-cycle, atom property names of details are always converted to string property names in fired action's details . JWT is not used for security reasons - it is just good enough envelope protecting action against accidental corruption on its journey.","ref":"Toolbox.Scenario.UserAction.html#pack/3"},{"type":"function","title":"Toolbox.Scenario.UserAction.parse_raw_action/1","doc":"Parses string containing JSON to Toolbox.Scenario.UserAction .","ref":"Toolbox.Scenario.UserAction.html#parse_raw_action/1"},{"type":"type","title":"Toolbox.Scenario.UserAction.t/0","doc":"Fired user action. When action is fired by the user, it should be pushed to raw topic with current timestamp to be correctly reordered by Normalizer . Properties type and details should contain enough information for routing action to the target scenario. Property user is ID of user who fired the action, data contains extra information attached by environment where user fired the action (for example comment filled by the user on UI).","ref":"Toolbox.Scenario.UserAction.html#t:t/0"}]